#ifndef __CONFIGMODEL_H
#define __CONFIGMODEL_H
#include "types.h"
#include <dos/dos.h>

CONFIGFILEPTR ConfigFileRead(CONST_STRPTR filename);
VOID ConfigFileFree(CONFIGFILEPTR abstractConfigFile);

VOID ConfigFileSave(CONFIGFILEPTR config);

VOID InitialisePatterns(VOID);
VOID ReleasePatterns(VOID);

LINEPTR LineReadIncludingContinuation(BPTR file, SECTIONPTR currentSection, SECTIONSTOREPTR sectionStore);
VOID LineFree(LINEPTR abstractLine);
CONST_STRPTR LineGetRawText(LINEPTR line);

SECTIONPTR SectionCreateWithName(CONST_STRPTR primary);
SECTIONPTR SectionCreateWithNameAndSubname(CONST_STRPTR primary, CONST_STRPTR secondary);
VOID SectionFree(SECTIONPTR section);
CONST_STRPTR SectionCanonicalName(SECTIONPTR section);

VARIABLEPTR VariableCreate(CONST_STRPTR key, CONST_STRPTR rawValue);
VOID VariableFree(VARIABLEPTR abstractVariable);

#endif